%define name dmraid
%define version 1.0.0
%define extraver rc16
#define pre pre1
%define rel 1

# from lib/version.h
%define drmajor 1
%define drlibname %mklibname dmraid %drmajor
%define drdevname %mklibname dmraid -d

# we need the libs in /lib(64) as /usr might not be mounted
%define _libdir /%{_lib}

# yes this sucks, but it has to
%if %{?extraver:1}%{?!extraver:0}
%if %{?pre:1}%{?!pre:0}
%define release %manbo_mkrel 0.%{extraver}.0.%{pre}.%{rel}
%define extrasrc .%{extraver}-%{pre}
%else
%define release %manbo_mkrel 0.%{extraver}.%{rel}
%define extrasrc .%{extraver}
%endif
%endif

%ifarch %{ix86} x86_64
%define use_dietlibc 0
%else
%define use_dietlibc 0
%endif

%{?_with_dietlibc: %{expand: %%global use_dietlibc 1}}
%{?_without_dietlibc: %{expand: %%global use_dietlibc 0}}

# Building of dmraid-event-logwatch (disabled by default)
%define build_logwatch 0
%{?_with_logwatch: %{expand: %%global build_logwatch 1}}
%{?_without_logwatch: %{expand: %%global build_logwatch 0}}

Summary: Device-mapper ATARAID tool
Name:	 %{name}
Version: %{version}
Release: %{release}
Source0: http://people.redhat.com/~heinzm/sw/dmraid/src/dmraid-%{version}%{extrasrc}.tar.bz2

# From RedHat
Patch1:	ddf1_lsi_persistent_name.patch
Patch2:	pdc_raid10_failure.patch
Patch4:	avoid_register.patch
Patch6:	libversion.patch
Patch7:	libversion-display.patch
# /From RedHat
Patch3:	lib-events-libdmraid-events-isw-strfmt.patch
Patch5:	fix-linking.patch
Patch8:	libdmraid-events-install.patch

License: GPLv2+
Group:   System/Kernel and hardware
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL: http://people.redhat.com/~heinzm
Requires:	kpartx >= 0.4.8-16
Requires:	%{drlibname} = %{version}-%{release}
Requires:	dmraid-events = %{version}-%{release}
BuildRequires:	device-mapper-devel >= 1.02.02
BuildRequires:	device-mapper-event-devel >= 1.02.02
%if %{use_dietlibc}
BuildRequires: dietlibc-devel
%else
BuildRequires: glibc-static-devel
%endif

%description
dmraid (Device-Mapper Raid tool) supports RAID device discovery, RAID
set activation, creation, removal, rebuild and display of properties for
ATARAID/DDF1 metadata.

dmraid uses libdevmapper and the device-mapper kernel runtime to create
devices with respective mappings for the ATARAID sets discovered.

The following ATARAID types are supported:

Adaptec HostRAID ASR
Highpoint HPT37X
Highpoint HPT45X
Intel Software RAID
JMicron JMB36x
LSI Logic MegaRAID
NVidia NForce
Promise FastTrack
Silicon Image Medley
SNIA DDF1
VIA Software RAID


%package -n %{drlibname}
Summary:  Libraries for dmraid
Group:    System/Libraries

%description -n %{drlibname}
Provides libraries for dmraid.


%package -n %{drdevname}
Summary:  Development libraries and headers for dmraid
Group:    System/Libraries

%description -n %{drdevname}
Provides a library interface for RAID device discovery, RAID set
activation and display of properties for ATARAID volumes.


%package events
Summary:  Dmraid event tool
Group:    System/Base
Requires: dmraid = %{version}-%{release}
Requires: device-mapper-event  >= 1.02.02

%description events
Provides a dmeventd DSO and the dmevent_tool to register devices with it
for device monitoring. All active RAID sets should be manually registered
with dmevent_tool.


%if %{build_logwatch}
%package events-logwatch
Summary:  Dmraid logwatch-based email reporting
Group:    System/Base
Requires: dmraid-events = %{version}-%{release}, logwatch, /etc/cron.d

%description events-logwatch
Provides device failure reporting via logwatch-based email reporting.
Device failure reporting has to be activated manually by activating the
/etc/cron.d/dmeventd-logwatch entry and by calling the dmevent_tool
(see manual page for examples) for any active RAID sets.
%endif


%prep
%setup -q -n %{name}/%{version}.%{extraver}
%patch1 -p1 -b .ddf1_lsi_persistent_name
%patch2 -p1 -b .pdc_raid10_failure
%patch3 -p1 -b .libdmraid_events_isw_strfmt
%patch4 -p1 -b .avoid_register
%patch5 -p1 -b .linking
%patch6 -p1 -b .libversion
%patch7 -p1 -b .libversion_display
%patch8 -p1 -b .lib_events_install


%build
%define common_configure_parameters --with-user=`id -un` --with-group=`id -gn` --disable-libselinux --disable-libsepol --enable-led --enable-intel_led
%if %{use_dietlibc}
CFLAGS="%{optflags} -D_BSD_SOURCE" \
%configure2_5x --enable-dietlibc %{common_configure_parameters}
%else
%configure2_5x --enable-static_link %{common_configure_parameters}
%endif
make
mv tools/dmraid tools/dmraid-static
make clean
%configure2_5x %{common_configure_parameters} --enable-dynamic_link
make


%install
rm -rf %{buildroot}
mkdir -p %{buildroot}{%{_libdir},/sbin,/var/lock/dmraid,/etc/cron.d/,/etc/logwatch/conf/services/,/etc/logwatch/scripts/services/}
%makeinstall -s sbindir=%{buildroot}/sbin
install tools/dmraid-static %{buildroot}/sbin
install -m 644 include/dmraid/*.h %{buildroot}%{_includedir}/dmraid/

%if %{build_logwatch}
# Install logwatch config file and script for dmeventd
install -m 644 logwatch/dmeventd.conf %{buildroot}/etc/logwatch/conf/services/dmeventd.conf
install -m 755 logwatch/dmeventd %{buildroot}/etc/logwatch/scripts/services/dmeventd
install -m 644 logwatch/dmeventd_cronjob.txt %{buildroot}/etc/cron.d/dmeventd-logwatch
install -m 0700 /dev/null %{buildroot}/etc/logwatch/scripts/services/dmeventd_syslogpattern.txt
%endif


%clean
rm -rf %{buildroot}

%post   -n %{drlibname} -p /sbin/ldconfig
%postun -n %{drlibname} -p /sbin/ldconfig


%files
%defattr(644,root,root,755)
%doc CHANGELOG KNOWN_BUGS README TODO doc/dmraid_design.txt
%attr(755,root,root) /sbin/dmraid
%attr(755,root,root) /sbin/dmraid-static
%{_mandir}/man8/dmraid.8*
/var/lock/dmraid

%files -n %{drlibname}
%defattr(644,root,root,755)
%{_libdir}/libdmraid.so.%{drmajor}*

%files -n %{drdevname}
%defattr(-,root,root)
%dir %{_includedir}/dmraid
%{_includedir}/dmraid/*
%{_libdir}/libdmraid.a
%{_libdir}/libdmraid.so

%files events
%defattr(-,root,root)
%attr(755,root,root) /sbin/dmevent_tool
%{_libdir}/libdmraid-events-isw.so*
%{_mandir}/man8/dmevent_tool*

%if %{build_logwatch}
%files events-logwatch
%defattr(-,root,root)
%config(noreplace) /etc/logwatch/*
%config(noreplace) /etc/cron.d/dmeventd-logwatch
%ghost /etc/logwatch/scripts/services/dmeventd_syslogpattern.txt
%endif


%changelog
* Thu Mar 11 2010 Thomas Backlund <tmb@mandriva.org> 1.0.0-0.rc16.1mnb2
+ Revision: 518246
- fix Groups
- libdmraid-event-* is a loadable plugin, not a shared library
- split out libraries
- set DMRAID_LIB_VERSION to 1 (from fedora)
- consolidate configure flags
- fix linking
- silence run-time messages about non-existant events modules (from redhat)
- disable ld_as_needed for now due to linking problems
- small fixups to spec and summarys
- license is GPLv2+
- disable ld_no_undefined for now to fix linking
- install libs in /lib(64)
- add devel, events and events-logwatch subpackages (events-logwatch disabled by default)
- update configure flags:  --disable-libsepol --enable-led --enable-intel_led
- update description
- add requires on kpartx and dmraid-events
- update buildrequires on device-mapper-devel version, add device-mapper-event-devel
- fix string format error in libdmraid-events-isw
- fix pdc raid10 failure (from redhat)
- fix persistent name for lsi ddf1 (from redhat)
- drop merged and obsolete patches
- update to 1.0.0-rc16

* Tue Jun 30 2009 Pascal Terjan <pterjan@mandriva.org> 1.0.0-0.rc15.1mnb2
+ Revision: 391122
- Add current Fedora patches, P3 is needed as mkinitrd uses added option
- Update to rc15 and drop all patches merged upstream

* Fri Sep 26 2008 Pixel <pixel@mandriva.com> 1.0.0-0.rc14.7mnb2
+ Revision: 288610
- force to use isw_xxxxp1 instead of isw_xxxx1 (see #42542, #44182)

* Mon Aug 25 2008 Pixel <pixel@mandriva.com> 1.0.0-0.rc14.6mnb2
+ Revision: 275669
- tentative fix for isw_xxxx_Volume0p1 vs isw_xxxx_Volume01 device name (#42542)

* Tue Jun 10 2008 Oden Eriksson <oeriksson@mandriva.com> 1.0.0-0.rc14.5mnb2
+ Revision: 217572
- rebuilt against dietlibc-devel-0.32

* Mon Feb 18 2008 Thierry Vignaud <tv@mandriva.org> 1.0.0-0.rc14.4mnb1
+ Revision: 171224
- replace %%mkrel with %%manbo_mkrel for Manbo Core 1

  + Pixel <pixel@mandriva.com>
    - drop specific *old* require on dietlibc-devel version (it breaks on Manbo)

* Thu Feb 14 2008 Olivier Blin <oblin@mandriva.com> 1.0.0-0.rc14.4mdv2008.1
+ Revision: 167205
- define _BSD_SOURCE to be able to use uint type from UUID patch with dietlibc
- merge Fedora patches (jmicron name parsing fix, UUID fixes, mirror resynchronization error handling fix)
- use new version of the "dmraid -r -E" segfault fix (from Ian Kent on ataraid-list@)

* Fri Dec 21 2007 Olivier Blin <oblin@mandriva.com> 1.0.0-0.rc14.3mdv2008.1
+ Revision: 136367
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Sep 14 2007 Luca Berra <bluca@mandriva.org> 1.0.0-0.rc14.3mdv2008.0
+ Revision: 85465
- add raid10 support for isw format
- fix segfault issue with dmraid -r -E with isw
- improve Promise FastTrack metadata detection

* Wed May 09 2007 Gwenole Beauchesne <gbeauchesne@mandriva.org> 0.rc14.2mdv2008.0-current
+ Revision: 25740
- rebuild against a fixed dietlibc version

* Tue Apr 17 2007 Thierry Vignaud <tv@mandriva.org> 1.0.0-0.rc14.1mdv2008.0
+ Revision: 13794
- new release (from fedora); kill old fedora patches


* Thu Aug 10 2006 Luca Berra <bluca@comedia.it>
+ 08/10/06 07:25:31 (55300)
added more secret fedora patches

* Thu Aug 10 2006 Luca Berra <bluca@comedia.it>
+ 08/10/06 06:59:51 (55298)
Import dmraid

* Tue May 23 2006 Luca Berra <bluca@vodka.it> 1.0.0-0.rc11.1mdk
- rc11 from rawhide (ugh, it seems rawhide is more uptodate than upstream)

* Sun May 21 2006 Luca Berra <bluca@vodka.it> 1.0.0-0.rc11.0.pre1.1mdk
- new pre-release (should fix the stripe issue with kernel > 2.6.16)
- drop patch 2 (merged upstream)
- support pre-rc releases in spec
- re-enable dietlibc for x86_64 and require a fixed dietlibc

* Tue Feb 21 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.0.0-0.rc10.1mdk
- new release
- update description
- drop patch 1 (obsoleted by build system)
- patch 2: fix using autoconf

* Sun Feb 05 2006 Thomas Backlund <tmb@mandriva.org> 1.0.0-0.rc9.4mdk
- Fix buildrequires when building without dietlibc
- Fix configure for static build without dietlibc
- build x86_64 without dietlibc for now to work around
  ContraPolice Heap Buffer Overflow Crash

* Fri Jan 06 2006 Oden Eriksson <oeriksson@mandriva.com> 1.0.0-0.rc9.3mdk
- drop selinux support (P1)

* Mon Oct 03 2005 Nicolas Lcureuil <neoclust@mandriva.org> 1.0.0-0.rc9.2mdk
- BuildRequires fix

* Mon Oct 03 2005 Pixel <pixel@mandriva.com> 1.0.0-0.rc9.1mdk
- new release
- drop lib64 patch which is applied upstream
- drop patch4 (typo fix applied upstream)
- we don't want the dmraid devel files

* Fri May 27 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.0-0.rc8.1mdk
- new release

* Thu Apr 28 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.0-0.rc7.1mdk
- new release
- rediff patch

* Thu Mar 10 2005 Pixel <pixel@mandrakesoft.com> 1.0.0-0.rc6.4mdk
- don't require old libdevmapper 1.00

* Tue Mar 08 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.0.0-0.rc6.3mdk
- Patch4: fix typo in pdc big endian only code

* Sat Mar 05 2005 Luca Berra <bluca@vodka.it> 1.0.0-0.rc6.2mdk 
- rebuild for new libdevmapper

* Wed Mar 02 2005 Luca Berra <bluca@vodka.it> 1.0.0-0.rc6.1mdk 
- rc6
- removed p2 (big endian fix, merged upstream)
- remove Prefix: tag

* Mon Feb 21 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.0.0-0.rc5f.3mdk
- lib64 fixes

* Sat Feb 12 2005 Christiaan Welvaart <cjw@daneel.dyndns.org> 1.0.0-0.rc5f.2mdk
- fix build on big endian cpus

* Thu Jan 13 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.0.0-0.rc5f.1mdk
- new release
- update description
- spec cleanups

* Tue Sep 07 2004 Luca Berra <bluca@vodka.it> 1.0.0-0.rc4.1mdk 
- rc4
- fix source url
- remove -s from make (fixed upstream)

* Sun Sep 05 2004 Luca Berra <bluca@vodka.it> 1.0.0-0.rc3.1mdk 
- rc3
- remove p0 merged upstream

* Thu Jul 22 2004 Luca Berra <bluca@vodka.it> 1.0.0-0.rc2.1mdk 
- initial mandrakelinux release

